"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMintWithAssociatedToken = void 0;
const createMint_1 = require("./createMint");
const generated_1 = require("./generated");
const hooked_1 = require("./hooked");
function createMintWithAssociatedToken(context, input) {
    const mintAndOwner = { mint: input.mint.publicKey, owner: input.owner };
    const amount = input.amount ?? 0;
    const instructions = [
        ...(0, createMint_1.createMint)(context, input),
        (0, generated_1.createAssociatedToken)(context, mintAndOwner),
    ];
    if (amount > 0) {
        instructions.push((0, generated_1.mintTokensTo)(context, {
            amount,
            mint: input.mint.publicKey,
            token: (0, hooked_1.findAssociatedTokenPda)(context, mintAndOwner),
        }));
    }
    return instructions;
}
exports.createMintWithAssociatedToken = createMintWithAssociatedToken;
//# sourceMappingURL=createMintWithAssociatedToken.js.map