"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.approveTokenDelegateChecked = exports.getApproveTokenDelegateCheckedInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getApproveTokenDelegateCheckedInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['amount', s.u64()],
        ['decimals', s.u8()],
    ], { description: 'ApproveTokenDelegateCheckedInstructionData' }), (value) => ({
        ...value,
        discriminator: 13,
    }));
}
exports.getApproveTokenDelegateCheckedInstructionDataSerializer = getApproveTokenDelegateCheckedInstructionDataSerializer;
function approveTokenDelegateChecked(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const sourceAccount = input.source;
    const mintAccount = input.mint;
    const delegateAccount = input.delegate;
    const ownerAccount = input.owner;
    keys.push({
        pubkey: sourceAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(sourceAccount, true),
    });
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, false),
    });
    keys.push({
        pubkey: delegateAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(delegateAccount, false),
    });
    signers.push(ownerAccount);
    keys.push({
        pubkey: ownerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(ownerAccount, false),
    });
    const data = getApproveTokenDelegateCheckedInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.approveTokenDelegateChecked = approveTokenDelegateChecked;
//# sourceMappingURL=approveTokenDelegateChecked.js.map