import { Context, PublicKey, Serializer, Signer, WrappedInstruction } from '@metaplex-foundation/umi';
export type BurnTokenInstructionAccounts = {
    account: PublicKey;
    mint: PublicKey;
    authority?: Signer;
};
export type BurnTokenInstructionData = {
    discriminator: number;
    amount: bigint;
};
export type BurnTokenInstructionDataArgs = {
    amount: number | bigint;
};
export declare function getBurnTokenInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<BurnTokenInstructionDataArgs, BurnTokenInstructionData>;
export declare function burnToken(context: Pick<Context, 'serializer' | 'programs' | 'identity'>, input: BurnTokenInstructionAccounts & BurnTokenInstructionDataArgs): WrappedInstruction;
