"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.closeToken = exports.getCloseTokenInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getCloseTokenInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], {
        description: 'CloseTokenInstructionData',
    }), (value) => ({ ...value, discriminator: 9 }));
}
exports.getCloseTokenInstructionDataSerializer = getCloseTokenInstructionDataSerializer;
function closeToken(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const accountAccount = input.account;
    const destinationAccount = input.destination;
    const ownerAccount = input.owner;
    keys.push({
        pubkey: accountAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(accountAccount, true),
    });
    keys.push({
        pubkey: destinationAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(destinationAccount, true),
    });
    signers.push(ownerAccount);
    keys.push({
        pubkey: ownerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(ownerAccount, false),
    });
    const data = getCloseTokenInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.closeToken = closeToken;
//# sourceMappingURL=closeToken.js.map