import { Context, Pda, PublicKey, Serializer, Signer, WrappedInstruction } from '@metaplex-foundation/umi';
export type CreateLutInstructionAccounts = {
    address?: Pda;
    authority?: Signer;
    payer?: Signer;
    systemProgram?: PublicKey;
};
export type CreateLutInstructionData = {
    discriminator: number;
    recentSlot: bigint;
    bump: number;
};
export type CreateLutInstructionDataArgs = {
    recentSlot: number | bigint;
    bump: number;
};
export declare function getCreateLutInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<CreateLutInstructionDataArgs, CreateLutInstructionData>;
export declare function createLut(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: CreateLutInstructionAccounts & Omit<CreateLutInstructionDataArgs, 'bump'>): WrappedInstruction;
