"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deactivateLut = exports.getDeactivateLutInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getDeactivateLutInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u32()]], {
        description: 'DeactivateLutInstructionData',
    }), (value) => ({ ...value, discriminator: 3 }));
}
exports.getDeactivateLutInstructionDataSerializer = getDeactivateLutInstructionDataSerializer;
function deactivateLut(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splAddressLookupTable', 'AddressLookupTab1e1111111111111111111111111');
    const addressAccount = input.address;
    const authorityAccount = input.authority ?? context.identity;
    keys.push({
        pubkey: addressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(addressAccount, true),
    });
    signers.push(authorityAccount);
    keys.push({
        pubkey: authorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(authorityAccount, false),
    });
    const data = getDeactivateLutInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.deactivateLut = deactivateLut;
//# sourceMappingURL=deactivateLut.js.map