"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeImmutableOwner = exports.getInitializeImmutableOwnerInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeImmutableOwnerInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], { description: 'InitializeImmutableOwnerInstructionData' }), (value) => ({
        ...value,
        discriminator: 22,
    }));
}
exports.getInitializeImmutableOwnerInstructionDataSerializer = getInitializeImmutableOwnerInstructionDataSerializer;
function initializeImmutableOwner(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const accountAccount = input.account;
    keys.push({
        pubkey: accountAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(accountAccount, true),
    });
    const data = getInitializeImmutableOwnerInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeImmutableOwner = initializeImmutableOwner;
//# sourceMappingURL=initializeImmutableOwner.js.map