"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeMint = exports.getInitializeMintInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeMintInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['decimals', s.u8()],
        ['mintAuthority', s.publicKey()],
        ['freezeAuthority', s.option(s.publicKey())],
    ], { description: 'InitializeMintInstructionData' }), (value) => ({ ...value, discriminator: 0 }));
}
exports.getInitializeMintInstructionDataSerializer = getInitializeMintInstructionDataSerializer;
function initializeMint(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const mintAccount = input.mint;
    const rentAccount = input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111');
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, true),
    });
    keys.push({
        pubkey: rentAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(rentAccount, false),
    });
    const data = getInitializeMintInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeMint = initializeMint;
//# sourceMappingURL=initializeMint.js.map