"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeMint2 = exports.getInitializeMint2InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeMint2InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['decimals', s.u8()],
        ['mintAuthority', s.publicKey()],
        ['freezeAuthority', s.option(s.publicKey())],
    ], { description: 'InitializeMint2InstructionData' }), (value) => ({ ...value, discriminator: 20 }));
}
exports.getInitializeMint2InstructionDataSerializer = getInitializeMint2InstructionDataSerializer;
function initializeMint2(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const mintAccount = input.mint;
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, true),
    });
    const data = getInitializeMint2InstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeMint2 = initializeMint2;
//# sourceMappingURL=initializeMint2.js.map