"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeMultisig = exports.getInitializeMultisigInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeMultisigInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['m', s.u8()],
    ], { description: 'InitializeMultisigInstructionData' }), (value) => ({ ...value, discriminator: 2 }));
}
exports.getInitializeMultisigInstructionDataSerializer = getInitializeMultisigInstructionDataSerializer;
function initializeMultisig(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const multisigAccount = input.multisig;
    const rentAccount = input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111');
    keys.push({
        pubkey: multisigAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(multisigAccount, true),
    });
    keys.push({
        pubkey: rentAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(rentAccount, false),
    });
    const data = getInitializeMultisigInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeMultisig = initializeMultisig;
//# sourceMappingURL=initializeMultisig.js.map