"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeMultisig2 = exports.getInitializeMultisig2InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeMultisig2InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['m', s.u8()],
    ], { description: 'InitializeMultisig2InstructionData' }), (value) => ({ ...value, discriminator: 19 }));
}
exports.getInitializeMultisig2InstructionDataSerializer = getInitializeMultisig2InstructionDataSerializer;
function initializeMultisig2(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const multisigAccount = input.multisig;
    const signerAccount = input.signer;
    keys.push({
        pubkey: multisigAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(multisigAccount, true),
    });
    keys.push({
        pubkey: signerAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(signerAccount, false),
    });
    const data = getInitializeMultisig2InstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeMultisig2 = initializeMultisig2;
//# sourceMappingURL=initializeMultisig2.js.map