"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeToken2 = exports.getInitializeToken2InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeToken2InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['owner', s.publicKey()],
    ], { description: 'InitializeToken2InstructionData' }), (value) => ({ ...value, discriminator: 16 }));
}
exports.getInitializeToken2InstructionDataSerializer = getInitializeToken2InstructionDataSerializer;
function initializeToken2(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const accountAccount = input.account;
    const mintAccount = input.mint;
    const rentAccount = input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111');
    keys.push({
        pubkey: accountAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(accountAccount, true),
    });
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, false),
    });
    keys.push({
        pubkey: rentAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(rentAccount, false),
    });
    const data = getInitializeToken2InstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeToken2 = initializeToken2;
//# sourceMappingURL=initializeToken2.js.map