"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeToken3 = exports.getInitializeToken3InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getInitializeToken3InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['owner', s.publicKey()],
    ], { description: 'InitializeToken3InstructionData' }), (value) => ({ ...value, discriminator: 18 }));
}
exports.getInitializeToken3InstructionDataSerializer = getInitializeToken3InstructionDataSerializer;
function initializeToken3(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const accountAccount = input.account;
    const mintAccount = input.mint;
    keys.push({
        pubkey: accountAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(accountAccount, true),
    });
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, false),
    });
    const data = getInitializeToken3InstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.initializeToken3 = initializeToken3;
//# sourceMappingURL=initializeToken3.js.map