"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestHeapFrame = exports.getRequestHeapFrameInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getRequestHeapFrameInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['bytes', s.u32()],
    ], { description: 'RequestHeapFrameInstructionData' }), (value) => ({ ...value, discriminator: 1 }));
}
exports.getRequestHeapFrameInstructionDataSerializer = getRequestHeapFrameInstructionDataSerializer;
function requestHeapFrame(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splComputeBudget', 'ComputeBudget111111111111111111111111111111');
    const data = getRequestHeapFrameInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.requestHeapFrame = requestHeapFrame;
//# sourceMappingURL=requestHeapFrame.js.map