"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestUnits = exports.getRequestUnitsInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getRequestUnitsInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['units', s.u32()],
        ['additionalFee', s.u32()],
    ], { description: 'RequestUnitsInstructionData' }), (value) => ({ ...value, discriminator: 0 }));
}
exports.getRequestUnitsInstructionDataSerializer = getRequestUnitsInstructionDataSerializer;
function requestUnits(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splComputeBudget', 'ComputeBudget111111111111111111111111111111');
    const data = getRequestUnitsInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.requestUnits = requestUnits;
//# sourceMappingURL=requestUnits.js.map