"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferAllSol = exports.getTransferAllSolInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getTransferAllSolInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], {
        description: 'TransferAllSolInstructionData',
    }), (value) => ({ ...value, discriminator: 1 }));
}
exports.getTransferAllSolInstructionDataSerializer = getTransferAllSolInstructionDataSerializer;
function transferAllSol(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplSystemExtras', 'SysExL2WDyJi9aRZrXorrjHJut3JwHQ7R9bTyctbNNG');
    const sourceAccount = input.source ?? context.identity;
    const destinationAccount = input.destination;
    const systemProgramAccount = input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    };
    signers.push(sourceAccount);
    keys.push({
        pubkey: sourceAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(sourceAccount, true),
    });
    keys.push({
        pubkey: destinationAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(destinationAccount, true),
    });
    keys.push({
        pubkey: systemProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(systemProgramAccount, false),
    });
    const data = getTransferAllSolInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.transferAllSol = transferAllSol;
//# sourceMappingURL=transferAllSol.js.map