"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uiAmountToAmount = exports.getUiAmountToAmountInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getUiAmountToAmountInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['uiAmount', s.u64()],
    ], { description: 'UiAmountToAmountInstructionData' }), (value) => ({ ...value, discriminator: 24 }));
}
exports.getUiAmountToAmountInstructionDataSerializer = getUiAmountToAmountInstructionDataSerializer;
function uiAmountToAmount(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    const mintAccount = input.mint;
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, false),
    });
    const data = getUiAmountToAmountInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.uiAmountToAmount = uiAmountToAmount;
//# sourceMappingURL=uiAmountToAmount.js.map